##
##  spegla.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         spegla
Summary:      FTP Mirroring Tool
URL:          ftp://subzero.campus.luth.se/pub/spegla/
Vendor:       Jens A Nilsson
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        FTP
License:      BSD
Version:      1.1p4
Release:      20080101

#   package options
%option       with_ipv6  no

#   list of sources
Source0:      ftp://subzero.campus.luth.se/pub/spegla/spegla-%{version}.tar.gz
Source1:      spegla.conf
Source2:      spegla-mirror
Source3:      rc.spegla
Patch0:       spegla.patch
Patch1:       http://www.imasy.or.jp/~ume/ipv6/spegla-1.1p4-ipv6-20020129.diff.gz

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101
PreReq:       OpenPKG, openpkg >= 20160101

%description
    Spegla is fast mirroring tool for the File Transfer Protocol (FTP).

%track
    prog spegla = {
        version   = %{version}
        url       = ftp://subzero.campus.luth.se/pub/spegla/
        regex     = spegla-(__VER__)\.tar\.gz
    }

%prep
    %setup -q
    %patch -p0
    %patch -p0 -P 1

%build
    cp Makefile.linux Makefile
    %{l_shtool} subst \
        -e 's;gcc;$(CC);' \
        -e 's;^\(OBJS[  ]*=\);\1 regex/regcomp.o regex/regerror.o regex/regexec.o regex/regfree.o;' \
        Makefile
    for name in regex/regcomp regex/regerror regex/regexec regex/regfree; do
        echo "$name.o: $name.c" >>Makefile
        echo "	\$(CC) \$(CFLAGS) -o $name.o $name.c \$(DEFS)" >>Makefile
    done
    CC="%{l_cc}"
    CFLAGS="%{l_cflags -O} -c"
%if "%{with_ipv6}" == "yes"
    DEFS="-DINET6"
%else
    DEFS=""
%endif
    LDFLAGS=""
    case "%{l_platform -t}" in
       *-freebsd* ) DEFS="$DEFS -DFREEBSD"; LDFLAGS="$LDFLAGS -lcompat" ;;
       *-linux*   ) DEFS="$DEFS -DLINUX" ;;
       *-sunos*   ) DEFS="$DEFS -DSolaris -DMTYPES -DNOCDEFS -DPROGNAME=\\\"spegla\\\"" ;;
    esac
    %{l_make} %{l_mflags -O} \
        CC="$CC" CFLAGS="$CFLAGS" DEFS="$DEFS" LDFLAGS="$LDFLAGS"

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d \
        $RPM_BUILD_ROOT%{l_prefix}/etc/spegla \
        $RPM_BUILD_ROOT%{l_prefix}/man/man1 \
        $RPM_BUILD_ROOT%{l_prefix}/var/spegla/pkg
    %{l_shtool} install -c -s -m 755 \
        spegla $RPM_BUILD_ROOT%{l_prefix}/bin/
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE spegla-mirror} $RPM_BUILD_ROOT%{l_prefix}/bin/
    %{l_shtool} install -c -m 644 %{l_value -s -a} \
        %{SOURCE spegla.conf} $RPM_BUILD_ROOT%{l_prefix}/etc/spegla/
    %{l_shtool} install -c -m 644 \
        spegla.1 $RPM_BUILD_ROOT%{l_prefix}/man/man1/
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE rc.spegla} $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d/
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std} \
        '%config %{l_prefix}/etc/spegla/*'

%files -f files

%clean

